var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PREFIX = 'CHANGE_';

var toUpperCaseUnderline = function toUpperCaseUnderline(text) {
  return text.match(/([A-Z]?[a-z0-9]+)/g).map(function (item) {
    return item.toUpperCase();
  }).join('_');
};

var mutationGenerator = function mutationGenerator(modalArray) {
  return modalArray.reduce(function (previous, modal) {
    return _extends({}, previous, _defineProperty({}, '' + PREFIX + toUpperCaseUnderline(modal), function undefined(state, _ref) {
      var value = _ref.value;

      this.state[modal] = value;
    }));
  }, {});
};

var computedGenerator = function computedGenerator(modalArray) {
  return modalArray.reduce(function (previous, modal) {
    return _extends({}, previous, _defineProperty({}, modal, {
      get: function get() {
        return this.$store.state[modal];
      },
      set: function set(value) {
        this['' + PREFIX + toUpperCaseUnderline(modal)]({ value: value });
      }
    }));
  }, {});
};

var methodsGenerator = function methodsGenerator(modalArray) {
  return modalArray.map(function (field) {
    return '' + PREFIX + toUpperCaseUnderline(field);
  });
};

module.exports = {
  toUpperCaseUnderline: toUpperCaseUnderline,
  computedGenerator: computedGenerator,
  methodsGenerator: methodsGenerator,
  mutationGenerator: mutationGenerator
};